﻿using System;
using System.Text;
using System.Collections.Generic;

using NUnit.Framework;

namespace Dodoni.BasicComponents
{
    /// <summary>A unit test class for <see cref="IdentifierStringExtensions"/>.
    /// </summary>
    [TestFixture]
    public class IdentifierStringExtensionsTests
    {
        /// <summary>A test function that compares the result of <see cref="IdentifierStringExtensions.GetRelevantSubstring(String)"/>.
        /// </summary>
        [Test]
        public void GetRelevantSubstring_TestStringWithoutIgnoringStartCharacter_TestString()
        {
            string testString = "Example string which is equal to the relevant sub-string _1234567890_^#+*~/&'";

            Assert.AreEqual(testString, testString.GetRelevantSubstring());
        }

        /// <summary>A test function that compares the result of <see cref="IdentifierStringExtensions.GetRelevantSubstring(String)"/>.
        /// </summary>
        [Test]
        public void GetRelevantSubstring_TestStringWithSubstringToIgnore_RelevantSubstring()
        {
            string testString = "Relevant sub-string" + IdentifierString.IgnoringStartCharacter + " ignoring sub-string";
            string exected = "Relevant sub-string";

            Assert.AreEqual(exected, testString.GetRelevantSubstring());
        }
    }
}