﻿/*
   Copyright (C) 2011-2013 Markus Wendt
   All rights reserved.
 
   Redistribution and use in source and binary forms, including commercial applications, with or without modification, 
   are permitted provided that the following conditions are met: 
 
   1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 
      Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.

   2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following 
      disclaimer in the documentation and/or other materials provided with the distribution. 

   3. If you use this software in a product, an acknowledgment (see the following) in the product documentation is required. 
      The end-user documentation included with the redistribution, if any, must include the following acknowledgment: 

      "Dodoni.net (http://www.dodoni-project.net/) Copyright (C) 2011-2012 Markus Wendt" 

      Alternately, this acknowledgment may appear in the software itself, if and wherever such third-party acknowledgments normally appear. 

   4. Neither the name 'Dodoni.net' nor the names of its contributors may be used to endorse or promote products 
      derived from this software without specific prior written permission. For written permission, please contact info<at>dodoni-project.net. 

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, 
   BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
   SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
   OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
   For more information, please see http://www.dodoni-project.net/.
 */
using System;
using System.Text;
using System.Numerics;

namespace Dodoni.MathLibrary.Basics.LowLevel
{
    /// <summary>Provides routines of the Linear Algebra PACKage, see http://www.netlib.org/lapack/index.html, that are related to Linear Equations.
    /// </summary>
    public partial class LapackLinearEquations
    {
        #region public (readonly) members

        /// <summary>Provides routines to estimate conditional numbers of a specified Matrix.
        /// </summary>
        public readonly IMatrixConditionalNumbers MatrixConditionalNumbers = null;

        /// <summary>Provide routines to compute scaling factors to equilibrate a specified Matrix.
        /// </summary>
        public readonly IMatrixEquibration MatrixEquibration = null;

        /// <summary>Provide routines for Matrix factorization.
        /// </summary>
        public readonly IMatrixFactorization MatrixFactorization = null;

        /// <summary>Provide routines for Matrix inversion.
        /// </summary>
        public readonly IMatrixInversion MatrixInversion = null;

        /// <summary>Provides routines to solve Linear Equations.
        /// </summary>
        public readonly ISolver Solver = null;

        /// <summary>Provides routines to solve Linear Equations and returns some error estimation.
        /// </summary>
        public readonly IErrorEstimationSolver ErrorEstimationSolver = null;

        /// <summary>Provides driver routines for solving systems of linear equations.
        /// </summary>
        public readonly IDriverRoutines DriverRoutines = null;
        #endregion

        #region internal constructors

        /// <summary>Initializes a new instance of the <see cref="LapackLinearEquations" /> class.
        /// </summary>
        internal LapackLinearEquations()
        {
        }
        #endregion
    }
}