﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Dodoni.MathLibrary
{
    public class SpecialMathFunctions
    {
        /// <summary>Returns the value of the Heaviside function.
        /// </summary>
        /// <param name="x">The argument.</param>
        /// <returns>0 if <paramref name="x"/> is less or equal 0.0; otherwise 1.</returns>
        /// <remarks>This function take into account rounding errors by first adding
        /// <see cref="MachineConsts.Epsilon"/> to the argument <paramref name="x"/>.</remarks>
        public static int HeavisideFunction(double x)
        {
            return (x + MachineConsts.Epsilon <= 0) ? 0 : 1;
        }
    }
}
